/*
 Una colección es un grupo de elementos almacenados de forma conjunta en una misma estructura.
Implementaremos la clase abstracta Coleccion, que contendrá un grupo de enteros. 
Para su almacenamiento solo está permitido el empleo de tipos de datos primitivos. 
NO SE USARÁN clases como Array, ArrayList, List, Set, ... 
Las operaciones que permitirá hacer serán:
•	int size(): devuelve el número de elementos que contiene la colección.
•	boolean isEmpty(): indica si la colección está vacía.
•	boolean contains(int e): indica si contiene al entero e.
•	abstract boolean add(int e): añade el entero e a la colección (permite repetición 
de elementos dentro de la colección). Devuelve false solo en el caso de que no se
pueda añadir el elemento.
•	boolean remove(int e): elimina el entero e de la colección. Si e no está en la
colección devuelve false, en caso contrario, devuelve, true.
•	void clear(): vaciar la colección.
•	int[] toArray(): devuelve un array de enteros que contiene a todos los números
que hay en la colección.
•	String toString(): devuelve la colección expresada como String.
Debes verificar que funciona correctamente mediante los tests unitarios contenidos
en el archivo "ColeccionTest.java" que te proporciono en el apartado "Información de interés".

http://www.jtech.ua.es/j2ee/publico/lja-2012-13/sesion02-apuntes.html
http://www.jtech.ua.es/ayto/ctj/restringido/apuntes/sesion02-apuntes.htm
https://www.cartagena99.com/recursos/alumnos/apuntes/Fundamentos%20de%20la%20programacion%20JAVA_con_EJERCICIOS.pdf
https://www.campusmvp.es/recursos/post/3-formas-de-inicializar-colecciones-java-a-la-hora-de-declararlas.aspx
https://chuletasinformaticas.wordpress.com/2018/03/20/arraylist/
https://www.clasesdeinformaticaweb.com/java-desde-cero/colecciones-en-java/

 */
package portada.util;

import java.util.Arrays;

/**
 *
 * @author
 */
public abstract class Coleccion
  {
    class Nodo // Un nodo 
      {
        Integer elemento; // poner un Integer, en vez de Int, permite iniciar a "null", en cambio un int , no lo permitiria
        Coleccion resto;
       
      }
    Nodo inicio; // creamos una variable de Tipo Nodo, llamado Incio. La clase nodo tiene un Integer y una Coleccion llamad resto
    
    public Coleccion() // constructor por defecto, Las colecciones siempre empiezan a null
      {
        this.inicio=null; 
      }
    
    int size()//devuelve el número de elementos que contiene la colección.
      {
        if(isEmpty())
          {
            return 0;
          }
        if (inicio.resto == null)
          {
            return 1;
          }
        return (1+inicio.resto.size());
      }
    
    boolean isEmpty()//indica si la colección está vacía.
      {
        return(inicio==null);
      }

    boolean contains(int e)//indica si contiene al entero e.
      {
        if (isEmpty())
          {
            return false;
          }
        if (inicio.elemento==null && inicio.resto==null)
          {
            return false;
          }
        if(inicio.elemento==null && inicio.resto !=null)
          {
            return inicio.resto.contains(e);
          }
        if(inicio.elemento != null && inicio.resto==null)
          {
            if(inicio.elemento==e)
              {
                return true;  
              }
            return false;
          }
        
        if (inicio.elemento!= null && inicio.resto!=null)
          {
            if(inicio.elemento==e)
              {
                return true;
              }
          }
        return inicio.resto.contains(e);
      
      }
   	abstract boolean add(int e);
  //añade el entero e a la colección (permite repetición de elementos dentro de la colección). Devuelve false solo en el caso de que no se pueda añadir el elemento
    boolean remove(int e)//elimina el entero e de la colección. Si e no está en la colección devuelve false, en caso contrario, devuelve, true.
      {
      
     // boolean algo=true;
      
        if(isEmpty())//caso1
          {
            return false;
          }
        
        
        if (inicio.elemento==null && inicio.resto==null)//caso2
          {
            return false;
          }
        
        
        if(inicio.elemento==null && inicio.resto != null)//caso3
          {
            
            return inicio.resto.remove(e);
          }
        if(inicio.elemento != null && inicio.resto==null)//caso4
          {
            if(inicio.elemento==e)
              {
                return true;  
              }
            return false;
          }
        
        /*
        if(inicio.elemento != null && inicio.resto==null)//caso4
          {
            
            if(inicio.elemento==e)
              {
                return true;  
              }
            return false;
          }*/
        
        if (inicio.elemento!= null && inicio.resto!=null)//caso5
          {
            if(inicio.elemento==e)
              {
                inicio=inicio.resto.inicio;
                return true;
              }
            return false;
        }
        
        /*
        if (inicio.elemento!= null && inicio.resto!=null)//caso5
          {
            if(inicio.elemento==e)
              {
                inicio=inicio.resto.inicio;
                
               return true;
              }
          
            return false;
          }*/

        return inicio.resto.remove(e);
      
        
       
      }
    void clear()//vaciar la colección.
      {
        inicio=null;
      }
    int[] toArray()//devuelve un array de enteros que contiene a todos los números que hay en la colección.
      {
        if(isEmpty())
          {
            return(null);
          }
        int[] array;
        int tamano =size();
        array = new int[tamano];
        Coleccion aux = this;
        for(int i = 0; i<= tamano-1;i++)
          {
            array[i] = aux.inicio.elemento;
            aux=aux.inicio.resto;
          }
        return array;
      }
    @Override
   public  String toString()//devuelve la colección expresada como String.
      {
     
     
        String mensaje="";
        /*
        int[] arrayAux = toArray(); //= null
        String join="";
        if(isEmpty())
          {
            return "["+mensaje+"]";
          }
        if(!isEmpty())
          {
            for(int i=0; i<= arrayAux.length; i++)
              { 
                String algo="[";
                String algo2="]";
                
                for(i=0; i<= toArray().length; i++)
                  {
                //mensaje=algo+String.valueOf(i)+algo2;
                  
                  }
                
              }*/
                
                
            
          
          
            /*//ESTA SALIDA SE APROXIMA --> Expetede=[[1]], was: [1]
            for(int numero: toArray() )
              {
                
                mensaje=String.valueOf(numero);
              }*/
          
          /*
            for (int i=0; i<= arrayAux.length; i++)
              {
                mensaje=String.join(". ", String.valueOf(i));
              
              /*
            String arrayToString=String.join(". ", toArray().toString());
            mensaje=arrayToString;*/
              
          
          
          
          /*
            for(int numero: toArray() )
              {
                mensaje=String.valueOf(numero);
              }
          */
          
          
          /*
            int[] arrayAux;
          arrayAux = new int[size()];
            for (int i=1; i<=arrayAux.length; i++)
              {
                mensaje="["+String.valueOf(i)+"]";
              }*/
          
           if(isEmpty())
          {
            return "["+mensaje+"]";
          }
           else{
          //ESTO DE AQUI ABAJO FUNCIONA... PERO SE USA ARRAYS....
          mensaje = Arrays.toString(toArray()).replaceAll(",", "");}
          //*****************************************/
          //https://es.stackoverflow.com/questions/46524/java-llamar-un-metodo-que-devuelve-array-y-mostrarlo-sin-que-aparezca-la-direcc
            
          
          
          
          /*int[] arrayAux;
          arrayAux = new int[size()];
            for (int i=0; i<= arrayAux.length+1; i++)
              {
                
              }*/
            
            
          
          
          
      return mensaje;
      }
      
  }
