package portada.util;

import org.junit.Test;
import static org.junit.Assert.*;

/**
 *
 * @author 
 */
public class ArrayDinamicoTest {
  
  public ArrayDinamicoTest() {
  }

  /**
   * Test of setItem method, of class ArrayDinamico.
   */
  @Test
  public void testSetItem() throws Exception {
    int subTests = 0;
    System.out.println("setItem");
    Integer expResultIa;
    Integer resultIa;
    ArrayDinamico ad;

    
    subTests++;
    ad = new ArrayDinamico();
    expResultIa = null;
    resultIa = null;
    try {
      ad.setItem(0,1);
      resultIa = ad.getItem(0);
      fail ("ArrayDinamico vacío (setItem0, getItem)");
    } catch (Exception ex) {
      assertEquals("Este error no debería producirse. ArrayDinamico vacío (getItem0) " + ex.getMessage(),expResultIa, resultIa);
    }

    
    subTests++;   
    expResultIa = null;
    resultIa = null;
    try {
      ad.setItem(-1,1);
      resultIa = ad.getItem(0);
      fail ("ArrayDinamico vacío (setItem-1, getItem)");
    } catch (Exception ex) {
      assertEquals("Este error no debería producirse. ArrayDinamico vacío (getItem0) " + ex.getMessage(),expResultIa, resultIa);
    }

    
    subTests++;
    expResultIa = 20;
    ad.add(1);
    ad.add(2);
    ad.add(3);
    try {
      ad.setItem(0, 20);
      resultIa = ad.getItem(0);
      assertEquals("ArrayDinamico de tres elementos (add, add, add, setItem20, getItem)", expResultIa, resultIa);
    } catch (Exception e) {
      fail ("Esta excepción no debería producirse. ArrayDinamico de tres elementos (add, add, add, setItem20, getItem) " + e.getMessage());
    }

    
    subTests++;    
    expResultIa = 30;
    try {
      ad.setItem(1, 30);
      resultIa = ad.getItem(1);
      assertEquals("ArrayDinamico de tres elementos (setItem30, getItem)", expResultIa, resultIa);
    } catch (Exception e) {
      fail ("Esta excepción no debería producirse. ArrayDinamico de tres elementos (setItem30, getItem) " + e.getMessage());
    }

    
    subTests++;    
    expResultIa = 40;
    try {
      ad.setItem(2, 40);
      resultIa = ad.getItem(2);
      assertEquals("ArrayDinamico de tres elementos (setItem40, getItem)", expResultIa, resultIa);
    } catch (Exception e) {
      fail ("Esta excepción no debería producirse. ArrayDinamico de tres elementos (setItem40, getItem) " + e.getMessage());
    }

    
    subTests++;    
    expResultIa = null;
    resultIa = null;
    try {
      resultIa = ad.getItem(3);
      fail ("ArrayDinamico de tres elementos (getItem)");
    } catch (Exception ex) {
      assertEquals("Este error no debería producirse. ArrayDinamico vacío (getItem) " + ex.getMessage(),expResultIa, resultIa);
    }
    
    System.out.println(subTests++);
  }

  /**
   * Test of getItem method, of class ArrayDinamico.
   */
  @Test
  public void testGetItem() {
    System.out.println("getItem");
    int subTests = 0;
    Integer expResultIa;
    Integer resultIa;
    ArrayDinamico ad;
    

    subTests++;    
    ad = new ArrayDinamico();
    expResultIa = null;
    resultIa = null;
    try {
      resultIa = ad.getItem(0);
      fail ("ArrayDinamico vacío (getItem0)");
    } catch (Exception ex) {
      assertEquals("Este error no debería producirse. ArrayDinamico vacío (getItem0) " + ex.getMessage(),expResultIa, resultIa);
    }
    
    
    subTests++;    
    expResultIa = null;
    resultIa = null;
    try {
      resultIa = ad.getItem(-1);
      fail ("ArrayDinamico vacío (getItem-1)");
    } catch (Exception ex) {
      assertEquals("Este error no debería producirse. ArrayDinamico vacío (getItem-1) " + ex.getMessage(),expResultIa, resultIa);
    }

    
    subTests++;    
    expResultIa = 1;
    ad.add(1);
    ad.add(2);
    ad.add(3);
    try {
      resultIa = ad.getItem(0);
      assertEquals("ArrayDinamico de tres elementos (add,add,add,getItem)", expResultIa, resultIa);
    } catch (Exception e) {
      fail ("Esta excepción no debería producirse. ArrayDinamico de tres elementos (add,add,add,getItem) " + e.getMessage());
    }
    
    
    subTests++;    
    expResultIa = 2;
    try {
      resultIa = ad.getItem(1);
      assertEquals("ArrayDinamico de tres elementos (getItem)", expResultIa, resultIa);
    } catch (Exception e) {
      fail ("Esta excepción no debería producirse. ArrayDinamico de tres elementos (getItem) " + e.getMessage());
    }
    
    
    subTests++;    
    expResultIa = 3;
    try {
      resultIa = ad.getItem(2);
      assertEquals("ArrayDinamico de tres elementos (getItem)", expResultIa, resultIa);
    } catch (Exception e) {
      fail ("Esta excepción no debería producirse. ArrayDinamico de tres elementos (getItem) " + e.getMessage());
    }
    
    
    subTests++;    
    expResultIa = null;
    resultIa = null;
    try {
      resultIa = ad.getItem(3);
      fail ("ArrayDinamico de tres elementos (getItem)");
    } catch (Exception ex) {
      assertEquals("Este error no debería producirse. ArrayDinamico vacío (getItem) " + ex.getMessage(),expResultIa, resultIa);
    }
    
    System.out.println(subTests);
  }
    
  @Test
  public void testConstructor() {
    int subTests = 0;
    System.out.println("testConstructor");
    String expResultS;
    String resultS;
    ArrayDinamico ad;


    subTests++;    
    try {
      ad = new ArrayDinamico(0);
      fail("ArrayDinamico vacio (new0)");
    } catch (Exception e) {
      assertTrue(true);
    }
    

    subTests++;    
    expResultS = "[]";
    try {
      ad = new ArrayDinamico(1);
      resultS = ad.toString();
      assertEquals("Creo ArrayDinamico(1) (new1)", expResultS, resultS);
    } catch (Exception e) {
      fail ("Esta excepcion no debería producirse. Creo ArrayDinamico(1) (new1) " + e.getMessage());
    }
    
    
    subTests++;    
    expResultS = "[]";
    try {
      ad = new ArrayDinamico(2);
      resultS = ad.toString();
      assertEquals("Creo ArrayDinamico(2) (new2)", expResultS, resultS);
    } catch (Exception e) {
      fail ("Esta excepcion no debería producirse. Creo ArrayDinamico(2) (new2) " + e.getMessage());
    }
    

    //para complementar a contains
    subTests++;
    boolean expResultB;
    boolean resultB;
    expResultB = false;
    try {
      ad = new ArrayDinamico(1);
      resultB = ad.contains(0);
      assertEquals("Creo ArrayDinamico(1) vacio (new1,contains)", expResultB, resultB);
    } catch (Exception e) {
      fail ("Esta excepcion no debería producirse. Creo ArrayDinamico(1) vacio (new1,contains) " + e.getMessage());
    }

    
    //para complementar a contains
    subTests++;
    expResultB = false;
    try {
      ad = new ArrayDinamico(2);
      resultB = ad.contains(0);
      assertEquals("Creo ArrayDinamico(2) vacio (new2,contains)", expResultB, resultB);
    } catch (Exception e) {
      fail ("Esta excepcion no debería producirse. Creo ArrayDinamico(2) vacio (new2,contains) " + e.getMessage());
    }

    
    //para complementar a remove
    subTests++;
    expResultB = false;
    try {
      ad = new ArrayDinamico(1);
      resultB = ad.remove(0);
      assertEquals("Creo ArrayDinamico(1) vacio (new1,remove)", expResultB, resultB);
    } catch (Exception e) {
      fail ("Esta excepcion no debería producirse. Creo ArrayDinamico(1) vacio (new1,remove) " + e.getMessage());
    }
    
    
    //para complementar a remove
    subTests++;
    expResultB = false;
    try {
      ad = new ArrayDinamico(2);
      ad.setItem(1, 1);
      resultB = ad.remove(0);
      assertEquals("Creo ArrayDinamico(2) vacio (new2,setItem.remove)", expResultB, resultB);
    } catch (Exception e) {
      fail ("Esta excepcion no debería producirse. Creo ArrayDinamico(2) vacio (new2,setItem,remove) " + e.getMessage());
    }
    

    //para complementar a getNext
    subTests++;
    Integer expResultI;
    Integer resultI;
    expResultI = null;
    resultI = null;
    try {
      ad = new ArrayDinamico(0);
      resultI = ad.getNext();
      fail ("Este error no debería producirse. Creo ArrayDinamico(0) vacio (new0,getNext)");
    } catch (Exception e) {
      
      assertEquals("Creo ArrayDinamico(0) vacio (new0,getNext) " + e.getMessage(), expResultI, resultI);
    }
    
    
    //para complementar a getNext
    subTests++;
    expResultI = null;
    resultI = null;
    try {
      ad = new ArrayDinamico(1);
      resultI = ad.getNext();
      fail ("Este error no debería producirse. Creo ArrayDinamico(1) vacio (new1,getNext)");
    } catch (Exception e) {
      
      assertEquals("Creo ArrayDinamico(1) vacio (new1,getNext) " + e.getMessage(), expResultI, resultI);
    }
    
    
    
    //para complementar a getNext
    subTests++;
    expResultI = null;
    resultI = null;
    try {
      ad = new ArrayDinamico(2);
      resultI = ad.getNext();
      fail ("Este error no debería producirse. Creo ArrayDinamico(2) vacio (new2,getNext)");
    } catch (Exception e) {
      
      assertEquals("Creo ArrayDinamico(2) vacio (new2,getNext) " + e.getMessage(), expResultI, resultI);
    }
    
    

    //para complementar a getNext
    subTests++;
    expResultI = 1;
    resultI = null;
    try {
      ad = new ArrayDinamico(2);
      ad.setItem(1, 1);
      //ad.getNext();
      resultI = ad.getNext();
      assertEquals("Creo ArrayDinamico(2) (new2,setItem,getNext,getNext)", expResultI, resultI);
      
    } catch (Exception e) {
      fail ("Este error no debería producirse. Creo ArrayDinamico(2) (new2,setItem,getNext,getNext) " + e.getMessage());
      
    }
    System.out.println(subTests);
  }    
} //class
  

