package portada.util;

import org.junit.Test;
import static org.junit.Assert.*;

/**
 *
 * @author 
 */
public class ColeccionTest {
  
  public ColeccionTest() {
  }

  /**
   * Test of size method, of class Coleccion.
   */
  @Test
  public void testSize() {
    System.out.println("testSize");
    int subTests = 0;
    int expResult;
    int result;

    
    subTests++;
    Coleccion c = new ColeccionImpl();
    expResult = 0;
    result = c.size();
    assertEquals(expResult, result);

    
    subTests++;
    c.add(1);
    expResult = 1;
    result = c.size();
    assertEquals(expResult, result);

    
    subTests++;
    c.add(2);
    expResult = 2;
    result = c.size();
    assertEquals(expResult, result);
    

    subTests++;
    c.clear();
    expResult = 0;
    result = c.size();
    assertEquals(expResult, result);
    
    System.out.println(subTests);
  }

  /**
   * Test of isEmpty method, of class Coleccion.
   */
  @Test
  public void testIsEmpty() {
    System.out.println("isEmpty");
    int subTests = 0;
    boolean expResult;
    boolean result;
    

    subTests++;
    Coleccion c = new ColeccionImpl();
    expResult = true;
    result = c.isEmpty();
    assertEquals("Longitud 0", expResult, result);
    

    subTests++;
    c.add(1);
    expResult = false;
    result = c.isEmpty();
    assertEquals("Longitud 1",expResult, result);
    

    subTests++;
    c.add(2);
    expResult = false;
    result = c.isEmpty();
    assertEquals("Longitud 2",expResult, result);
    

    subTests++;
    c.clear();
    expResult = true;
    result = c.isEmpty();
    assertEquals("Longitud 0",expResult, result);
    
    System.out.println(subTests);
  }

  /**
   * Test of contains method, of class Coleccion.
   */
  @Test
  public void testContains() {
    System.out.println("contains");
    int subTests = 0;
    Coleccion c;
    

    subTests++;
    c = new ColeccionImpl();
    assertEquals("Coleccion vacía", false, c.contains(25));
    

    subTests++;
    c.add(1);
    assertEquals("Coleccion de un elemento", false, c.contains(25));
    

    subTests++;
    c.add(2);
    assertEquals("Coleccion de dos elementos", false, c.contains(25));
    

    subTests++;
    c.add(3);
    assertEquals("Coleccion de tres elementos", true, c.contains(1));
    

    subTests++;
    c.add(4);
    assertEquals("Coleccion de cuatro elementos", true, c.contains(2));
    

    subTests++;
    c.add(5);
    assertEquals("Coleccion de cinco elementos", true, c.contains(5));

    System.out.println(subTests);
  }


  /**
   * Test of remove method, of class Coleccion.
   */
  @Test
  public void testRemove() {
    System.out.println("remove");
    int subTests = 0;
    Coleccion c;
    boolean expResultB;
    boolean resultB;
    String expResultS;
    String resultS;
    
    
    subTests++;
    c = new ColeccionImpl();
    expResultB = false;
    resultB = c.remove(25);
    assertEquals("Coleccion vacía (remove)", expResultB, resultB);
    expResultS = "[]";
    resultS = c.toString();
    assertEquals("Colección vacía (remove, toString)", expResultS, resultS);


    subTests++;
    c.add(1);
    expResultB = false;
    resultB = c.remove(25);
    assertEquals("Coleccion de un elemento (remove)", expResultB, resultB);
    expResultS = "[1]";
    resultS = c.toString();
    assertEquals("Colección de un elemento (toStr)", expResultS, resultS);


    subTests++;
    c.add(2);
    expResultB = false;
    resultB = c.remove(25);
    assertEquals("Coleccion de dos elementos (add, remove)", expResultB, resultB);
    expResultS = "[1 2]";
    resultS = c.toString();
    assertEquals("Colección de dos elementos (add,remove, toStr)", expResultS, resultS);
    

    subTests++;//fallo aqui!
    c.add(1);
    expResultB = false;
    resultB = c.remove(25);
    assertEquals("Coleccion de tres elementos (add,remove)", expResultB, resultB);
    expResultS = "[1 2 1]";
    resultS = c.toString();
    assertEquals("Colección de tres elementos(add, remove, tStr)", expResultS, resultS);


    subTests++;
    c.add(5);
    c.remove(1);
    expResultB = false;
    resultB = c.remove(25);
    assertEquals("Coleccion de cuatro elementos (add, remove", expResultB, resultB);
    expResultS = "[2 1 5]";
    resultS = c.toString();
    assertEquals("Colección de cuatro elementos (add, remove, toStr)", expResultS, resultS);
    

    subTests++;
    c.remove(5);
    expResultB = false;
    resultB = c.remove(5);
    assertEquals("Coleccion de tres elementos (remove, remove)", expResultB, resultB);
    expResultS = "[2 1]";
    resultS = c.toString();
    assertEquals("Colección de tres elementos(remove, remove, toStr)", expResultS, resultS);
    
    System.out.println(subTests);
  }

  /**
   * Test of clear method, of class Coleccion.
   */
  @Test
  public void testClear() {
    System.out.println("clear");
    int subTests = 0;
    
    
    subTests++;    
    Coleccion c = new ColeccionImpl();
    c.clear();
    assertEquals("Coleccion recién creada", c.isEmpty(),true);
    

    subTests++;
    c.add(1);
    c.clear();
    assertEquals("Coleccion de 1 elemento vaciada", c.isEmpty(),true);
    

    subTests++;
    c.add(2);
    c.clear();
    assertEquals("Coleccion de 2 elementos vaciada", c.isEmpty(),true);
    
    System.out.println(subTests);
  }

  /**
   * Test of toArray method, of class Coleccion.
   */
  @Test
  public void testToArray() {
    System.out.println("toArray");
    int subTests = 0;
    Coleccion c;
    int[] expResult;
    int[] result;
    

    subTests++;
    c = new ColeccionImpl();
    expResult = null;
    result = c.toArray();
    assertArrayEquals("Coleccion vacía",expResult, result);
    

    subTests++;
    c.add(1);
    expResult = new int[] {1};
    result = c.toArray();
    assertArrayEquals("Coleccion de 1 elemento",expResult, result);


    subTests++;
    c.add(2);
    expResult = new int[] {1,2};
    result = c.toArray();
    assertArrayEquals("Coleccion de dos elementos",expResult, result);
    
    System.out.println(subTests);
  }

  /**
   * Test of toString method, of class Coleccion.
   */
  @Test
  public void testToString() {
    System.out.println("toString");
    int subTests = 0;
    String expResult;
    String result;
    Coleccion c;
    
    
    subTests++;    
    c = new ColeccionImpl();
    expResult = "[]";
    result = c.toString();
    assertEquals("Coleccion vacia",expResult, result);


    subTests++;    
    c.add(1);
    expResult = "[1]";
    result = c.toString();
    assertEquals("Coleccion de un elemento",expResult, result);
    

    subTests++;
    c.add(2);
    expResult = "[1 2]";
    result = c.toString();
    assertEquals("Coleccion de dos elementos",expResult, result);
    
    System.out.println(subTests);
  }

  public class ColeccionImpl extends Coleccion 
    {
      public boolean add(int e) 
        {
          if(isEmpty())
            {
              inicio = new Nodo();
              inicio.elemento=e;
              inicio.resto=null;
              return true;
            }
          if(inicio.resto != null)
            {
              return inicio.resto.add(e);
            }
          inicio.resto=new ColeccionImpl();
          return inicio.resto.add(e);
        }//metodo add
    }//class ColeccionImpl
  
}//class
