
package portada.util;

import java.util.logging.Level;
import java.util.logging.Logger;
import org.junit.Test;
import static org.junit.Assert.*;

/**
 *
 * @author
 */
public class ListaTest {
  
  public ListaTest() {
  }

  /**
   * Test of add method, of class Lista.
   */
  @Test
  public void testAdd() {
    System.out.println("add");
    int subTests = 0;
    Lista l;
    l = new Lista();   
    

    subTests++;
    l.add(1);
    assertEquals("Lista de un elemento (contains)", true, l.contains(1));
    assertEquals("Lista de un elemento (size)", 1, l.size());
    assertEquals("Lista de un elemento (toStr)", "[1]", l.toString());
    
    
    subTests++;
    l.add(2);
    assertEquals("Lista de dos elementos (contains)", true, l.contains(2));
    assertEquals("Lista de dos elementos (size)", 2, l.size());    
    assertEquals("Lista de dos elementos (toStr)", "[1 2]", l.toString());

    
    subTests++;
    l.add(3);
    assertEquals("Lista de tres elementos (contains)", true, l.contains(3));
    assertEquals("Lista de tres elementos (size)", 3, l.size());    
    assertEquals("Lista de tres elementos (toStr)", "[1 2 3]", l.toString());
    

    subTests++;
    l.add(1);
    assertEquals("Lista de cuatro elementos (contains)", true, l.contains(3));
    assertEquals("Lista de cuatro elementos (size)", 4, l.size());    
    assertEquals("Lista de cuatro elementos (toStr)", "[1 2 3 1]", l.toString());
    
    System.out.println(subTests);
  }

  /**
   * Test of hasNext method, of class Lista.
   */
  @Test
  public void testHasNext() {
    System.out.println("hasNext");
    int subTests = 0;
    Lista l;
    l = new Lista();
    boolean expResultB;
    boolean resultB;
    
    
    subTests++;    
    expResultB = false;
    l.reseteaIterador();
    resultB = l.hasNext();
    assertEquals("Lista vacía (reseteaIterador, hasNext)", expResultB, resultB);
    

    subTests++;
    l.add(1);
    expResultB = true;
    l.reseteaIterador();
    resultB = l.hasNext();
    assertEquals("Lista de un elemento (add, reseteaIterador, hasNext)", expResultB, resultB);
    

    subTests++;
    expResultB = false;
    l.reseteaIterador();
    try {
      l.getNext();
      resultB = l.hasNext();
      assertEquals("Lista de un elemento (reseteaIterador, getNext, hasNext)", expResultB, resultB);
    } catch (Exception e) {
      fail ("No debe producirse esta excepción. Lista de un elemento. (reseteaIterador, getNext) " + e.getMessage());
    }
    

    subTests++;
    l.add(2);
    expResultB = false;
    l.reseteaIterador();
    try {
      l.getNext();
      l.getNext();
      resultB = l.hasNext();
      assertEquals("Lista de dos elementos (reseteaIterador, getNext, getNext, hasNext)", expResultB, resultB);
    } catch (Exception e) {
      fail ("No debe producirse esta excepción. Lista de dos elementos. (reseteaIterador, getNext, getNext, hasNext) " + e.getMessage());
    }
    

    subTests++;
    expResultB = true;
    l.reseteaIterador();
    try {
      l.getNext();
      resultB = l.hasNext();
      assertEquals("Lista de dos elementos (reseteaIterador, getNext, hasNext)", expResultB, resultB);
    } catch (Exception e) {
      fail ("No debe producirse esta excepción. Lista de dos elementos. (reseteaIterador, getNext,hasNext) " + e.getMessage());
    }
    

    subTests++;
    expResultB = false;
    l.reseteaIterador();
    try {
      l.getNext();
      l.getNext();
      l.add(3);
      resultB = l.hasNext();
      assertEquals ("Lista de 2+1 elementos (reseteaIterador, getNext, getNext,add)", expResultB, resultB);
    } catch (Exception e) {
      fail ("No debe producirse esta excepcion. Lista de 2+1 elementos (reseteaIterador, getNext, getNext,add) " + e.getMessage());
    }
    

    subTests++;
    expResultB = false;
    l.reseteaIterador();
    try {
      l.getNext();
      l.getNext();
      l.remove(3);
      resultB = l.hasNext();
      assertEquals ("Lista de 3 elementos (reseteaIterador, getNext, getNext,remove)", expResultB, resultB);
    } catch (Exception e) {
      fail ("No debe producirse esta excepción. Lista de 3 elementos (reseteaIterador, getNext, getNext,remove) " + e.getMessage());
    }
    

    subTests++;
    expResultB = false;
    l.reseteaIterador();
    try {
      l.getNext();
      l.remove(2);
      resultB = l.hasNext();
      assertEquals ("Lista de 2 elementos (reseteaIterador, getNext, remove)", expResultB, resultB);
    } catch (Exception e) {
      fail ("No debe producirse esta excepción. Lista de 2 elementos (reseteaIterador, getNext, remove) " + e.getMessage());
    }
    
    System.out.println(subTests);
  }

  /**
   * Test of getNext method, of class Lista.
   */
  @Test
  public void testGetNext() {
    System.out.println("getNext");
    int subTests = 0;
    Lista l;
    l = new Lista();
    Integer expResultI = 10;
    Integer resultI = 10;
    

    subTests++;
    try {
      l.reseteaIterador();
      resultI = l.getNext();
      fail ("Lista vacia (reseteaIterador, getNext)");
    } catch (Exception e) {
      assertEquals ("Lista vacía (reseteaIterador, getNext)", expResultI, resultI);
    }
    
    
    subTests++;
    l.add(1);
    expResultI = 1;
    l.reseteaIterador();
    try {
      resultI = l.getNext();
      assertEquals("Lista de un elemento (add, reseteaIterador, getNext)", expResultI, resultI);
    } catch (Exception ex) {
      fail ("No debería producirse esta excepción. Lista de un elemento (add, reseteaIterador, getNext) " + ex.getMessage());
    }
        

    subTests++;
    l.add(2);
    expResultI = 2;
    l.reseteaIterador();
    try {
      l.getNext();
      resultI = l.getNext();
      assertEquals("Lista de dos elementos (reseteaIterador, getNext, getNext)", expResultI, resultI);
    } catch (Exception e) {
      fail ("No debe producirse esta excepción. Lista de dos elementos. (reseteaIterador, getNext, getNext) " + e.getMessage());
    }
        

    subTests++;
    expResultI = null;
    resultI = null;
    l.reseteaIterador();
    try {
      l.getNext();
      l.getNext();
      l.add(3);
      resultI = l.getNext();
      fail ("Lista de 2+1 elementos (reseteaIterador, getNext, getNext,add)");
    } catch (Exception e) {
      assertEquals ("No debe producirse este error. Lista de 2+1 elementos (reseteaIterador, getNext, getNext,add)", expResultI, resultI);
    }
    

    subTests++;
    expResultI = 10; //es indiferente, no lo debe llegar a comprobar
    l.reseteaIterador();
    try {
      l.getNext();
      l.getNext();
      l.remove(3);
      resultI = l.getNext();
      fail ("No debe producirse esta excepción. Lista de 3 elementos (reseteaIterador, getNext, getNext,remove, getNext)");
    } catch (Exception e) {
      assertTrue(true);
    }
    

    subTests++;
    l.add(3);
    expResultI = 3;
    l.reseteaIterador();
    try {
      l.getNext();
      l.remove(2);
      resultI = l.getNext();
      assertEquals ("Lista de 3 elementos (add, reseteaIterador, getNext, remove, getNext)", expResultI, resultI);
    } catch (Exception e) {
      fail ("No debe producirse esta excepción. Lista de 3 elementos (add, reseteaIterador, getNext, remove, getNext) " + e.getMessage());
    }
    
    System.out.println(subTests);
  }

  /**
   * Test of reseteaIterador method, of class Lista.
   */
  @Test
  public void testReseteaIterador() {
    System.out.println("reseteaIterador");
    int subTests = 0;
    Lista l;
    boolean expResultB;
    boolean resultB;
    

    subTests++;
    l = new Lista();
    expResultB = false;
    resultB = l.hasNext();
    l.reseteaIterador();
    assertEquals("Lista vacia (hasNext)", expResultB, resultB);
    

    subTests++;
    l.add(1);
    expResultB = true;
    try {
      l.reseteaIterador();
      resultB = l.hasNext();
      assertEquals("Lista de un elemento (add, reseteaIterador, hasNext)", expResultB, resultB);
    } catch (Exception e) {
      fail ("No debe producirse esta excepcion. Lista de un elemento (add, reseteaIterador, hasNext");
    }
    

    subTests++;
    expResultB = true;
    try {
      l.reseteaIterador();
      l.getNext();
      l.reseteaIterador();
      resultB = l.hasNext();
      assertEquals("Lista de un elemento (reseteaIterador,getNext, reseteaIterador)", expResultB, resultB);
    } catch (Exception e) {
      fail ("No debe producirse esta excepcion. Lista de un elemento (reseteaIterador,getNext, reseteaIterador");
    }
    
    System.out.println(subTests);

  }

  /**
   * Test of ordenar method, of class Lista.
   */
  @Test
  public void testOrdenar() {
    System.out.println("ordenar");
    int subTests = 0;
    Lista l;
    l = new Lista();
    String expResultS;
    String resultS;
    

    subTests++;    
    expResultS = "[]";
    l.ordenar();
    resultS = l.toString();
    assertEquals("Lista vacia (ordenar)", expResultS, resultS);
    

    subTests++;
    l.add(2);
    expResultS = "[2]";
    l.ordenar();
    resultS = l.toString();
    assertEquals("Lista de un elemento (add, ordenar)", expResultS, resultS);
    

    subTests++;
    l.add(1);
    l.add(3);
    expResultS = "[1 2 3]";
    l.ordenar();
    resultS = l.toString();
    assertEquals("Lista de dos elementos (add, add, ordenar)", expResultS, resultS);
    
    System.out.println(subTests);
  }
  
}
